package markov;

import java.util.Arrays;
import java.util.HashMap;
import java.util.Map;
import java.util.stream.Collectors;

// FIXME rename
public class Data {

	private final Map<Prefix, Lookup> data = new HashMap<>();

	public void add(Prefix p, Token t) {
		Lookup l = data.getOrDefault(p, new Lookup());
		l.add(t);
		data.put(p, l);
	}

	public Lookup fetch(Prefix p) {
		return data.get(p);
	}

	public Lookup info(Token... t) {
		return data.get(new Prefix(t));
	}

	public Lookup info(String... s) {
		return data.get(new Prefix(Arrays.stream(s).map(t -> new Token(t, Glyph.Type.word))
				.collect(Collectors.toList())));
	}

	@Override
	public String toString() {
		return "Data [data=" + data + "]";
	}

	public String dumpStats() {
		return "Total hits: "
				+ data.entrySet().stream()
						.sorted((o1,
								o2) -> -1 * Integer.compare(
										o1.getValue().getTotalCounts(),
										o2.getValue().getTotalCounts()))
						.map(e -> String.format("%s - %d", e.getKey(),
								e.getValue().getTotalCounts()))
						.collect(Collectors.joining(", "))
				+ "\n" + "Distinct possibilities "
				+ data.entrySet().stream()
						.sorted((o1,
								o2) -> -1 * Integer.compare(
										o1.getValue().getDistinctTokens(),
										o2.getValue().getDistinctTokens()))
						.map(e -> String.format("%s - %d", e.getKey(),
								e.getValue().getDistinctTokens()))
						.collect(Collectors.joining(", "));

	}

}
