package markov;

public class Glyph {
    public enum Type {
        word, interpunction, control, whitespace, empty
    }

    public static final Glyph Start = new Glyph(Type.control, "START");
    public static final Glyph End = new Glyph(Type.control, "END");

    private Type type;
    private String content;

    public Type getType() {
        return type;
    }

    public String getContent() {
        return content;
    }

    public Glyph(Type type, String content) {

        this.type = type;
        this.content = content;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        Glyph glyph = (Glyph) o;

        if (type != glyph.type) {
            return false;
        }else if(type == Type.control){
            return this == o;
        }
        return content != null ? content.equals(glyph.content) : glyph.content == null;
    }

    @Override
    public int hashCode() {
        int result = type != null ? type.hashCode() : 0;
        result = 31 * result + (content != null ? content.hashCode() : 0);
        return result;
    }

    @Override
    public String toString() {
        return "Glyph{" +
                "type=" + type +
                ", content='" + content + '\'' +
                '}';
    }
}
