package markov;

import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;
import java.util.stream.Stream;

public class ParserStreamStyle {

    public Stream<Token> collect(Stream<Glyph> glyphs) {
        Data data = new Data();

        final Container[] previous = new Container[]{null};
        return glyphs.map(g -> {
            Container o = new Container(g);
            o.p = previous[0];
            previous[0] = o;
            return o;
        }).flatMap(go -> {
            if (go.p != null && go.p.self != null && !go.self.getType().equals(go.p.self.getType())) {
                List<Glyph> containers = new ArrayList<>();
                Container c = go;
                do {
                    c = c.p;
                    containers.add(0, c.self);
                }
                while (c != null && c.p != null && c.p.self != null  &&
                        c.self.getType().equals(c.p.self.getType()));
                return Stream.<List<Glyph>>builder().add(containers).build();
            } else {
                return Stream.empty();
            }
        }).map(l -> {
            String content = l.stream().map(glyph -> glyph.getContent()).collect(Collectors.joining());
            Glyph.Type type = l.get(0).getType();
            return new Token(content, type);
        });
    }

    private static class Container {
        Container(Glyph self) {
            this.self = self;
        }

        final Glyph self;
        Container p;
    }

    ;
}
