package markov;

public class Parser_first_version {

    private final int prefix_length;

    public Parser_first_version(int prefix_length) {
        super();
        this.prefix_length = prefix_length;
    }

    public Data parse(String input) {
        Data data = new Data();
        for (String line : input.split("\n")) {
            line = line.replace("Kai☺UWE empfiehlt ", "");
            Token[] tokens = tokenize(line);
            for (int i = 0 + prefix_length; i < tokens.length; i++) {
                Prefix p = getPrefix(tokens, i);
                Token t = getToken(tokens, i);
                data.add(p, t);
            }
        }
        return data;
    }

    private Token[] tokenize(String line) {
        String[] strings = line.split(" ");
        Token[] tokens = new Token[strings.length + prefix_length + 1];

        int i = 0;
        for (; i < prefix_length; i++) {
            tokens[i] = Token.START;
        }
        for (; i < strings.length + prefix_length; i++) {
            tokens[i] = new Token(strings[i - prefix_length], Glyph.Type.word);
        }
        tokens[i] = Token.END;
        return tokens;
    }

    private Prefix getPrefix(Token[] tokens, int index) {
        Token[] prefixTokens = new Token[prefix_length];
        System.arraycopy(tokens, index - prefix_length + 1, prefixTokens, 0, prefix_length);
//		for (int i = 0; i < prefix_length; i++) {
//			prefixTokens[i] = tokens[index - prefix_length + i];
//		}
        return new Prefix(prefixTokens);
    }

    private Token getToken(Token[] tokens, int i) {
        return tokens[i];
    }
}
