package markov;

import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Nested;
import org.junit.jupiter.api.Test;

import java.util.Arrays;

import static org.junit.jupiter.api.Assertions.assertEquals;
import static org.junit.jupiter.api.Assertions.assertNull;
import static org.junit.jupiter.api.Assertions.assertTrue;

public class DataTests {

    Data data;

    @Test
    public void isInstantiatedWithNew() {
        data = new Data();
    }

    @Nested
    public class WhenNew {

        Prefix pa = new Prefix(new Token[]{new Token("")});
        Token ta = new Token("a");

        @BeforeEach
        public void create() {
            data = new Data();
            data.add(pa, ta);
        }

        @Test
        public void canReceieve() {
            assertTrue(data.fetch(pa).allPosible().contains(new Token("a")));
            assertEquals(1, data.fetch(pa).allPosible().size());
            data.add(pa, new Token("b"));
            assertTrue(data.fetch(pa).allPosible().contains(new Token("b")));
            assertEquals(2, data.fetch(pa).allPosible().size());
        }

        @Test
        public void cantReceieve() {
            assertNull(data.fetch(new Prefix(Arrays.asList(new Token("a")))));
        }
    }

}