package markov;

import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.Test;

import java.util.Arrays;
import java.util.stream.Collectors;
import java.util.stream.Stream;

class ParserStreamStyleTest {

    @Test
    void tests() {
        ParserStreamStyle parserStreamStyle = new ParserStreamStyle();
        Assertions.assertIterableEquals(
                Arrays.asList(
                        new Token(Glyph.Start.getContent(), Glyph.Type.control),
                        new Token("ab"),
                        new Token(" ", Glyph.Type.whitespace),
                        new Token("c"),
                        new Token(Glyph.End.getContent(), Glyph.Type.control)),
                parserStreamStyle.collect(Stream.of(Glyph.Start,
                        new Glyph(Glyph.Type.word, "a"),
                        new Glyph(Glyph.Type.word, "b"),
                        new Glyph(Glyph.Type.whitespace, " "),
                        new Glyph(Glyph.Type.word, "c"),
                        Glyph.End, new Glyph(Glyph.Type.empty, "EMPTY")))
                        .collect(Collectors.toList()));


    }
}