package markov;

import org.junit.jupiter.api.Test;

import java.util.Arrays;

import static org.junit.jupiter.api.Assertions.assertEquals;
import static org.junit.jupiter.api.Assertions.assertNotNull;

public class PrefixTests {

    Prefix prefix;

    @Test
    public void create() {
        prefix = new Prefix(Arrays.asList(new Token("a")));
        assertNotNull(prefix);
        assertEquals(new Prefix(Arrays.asList(new Token("a"))), prefix);
    }

    // FIXME
    @Test
    public void testStartCompression() {
        prefix = new Prefix(Arrays.asList(Token.START));
        assertEquals(new Prefix(Arrays.asList(Token.START)), prefix);
        assertEquals(new Prefix(Arrays.asList(Token.START, Token.START, Token.START)), prefix);
        prefix = new Prefix(Arrays.asList(Token.START, Token.START));
        assertEquals(new Prefix(Arrays.asList(Token.START)), prefix);

        prefix = new Prefix(Arrays.asList(Token.START, new Token("")));
        assertEquals(new Prefix(Arrays.asList(Token.START, new Token(""))), prefix);

        prefix = new Prefix(Arrays.asList(Token.START, new Token(""), new Token("")));
        assertEquals(new Prefix(Arrays.asList(Token.START, new Token(""), new Token(""))), prefix);
        assertEquals(new Prefix(Arrays.asList(Token.START, Token.START, Token.START, new Token(""), new Token(""))),
                prefix);
        prefix = new Prefix(Arrays.asList(Token.START, Token.START, new Token(""), new Token("")));
        assertEquals(new Prefix(Arrays.asList(Token.START, new Token(""), new Token(""))), prefix);
    }

    @Test
    public void testSlide() {
        prefix = new Prefix(Arrays.asList(new Token("a")));
        Prefix p2 = prefix.slide(new Token("b"));
        assertEquals(new Prefix(Arrays.asList(new Token("b"))), p2);

        prefix = new Prefix(Arrays.asList(new Token("a"), new Token("b")));
        p2 = prefix.slide(new Token("c"));
        assertEquals(new Prefix(Arrays.asList(new Token("b"), new Token("c"))), p2);
    }


}